
require('datejs');
const API_AI_PARAMETER = "Subst_feriados";
let packageUtil = {};

const KeywordUtil = require('./keyword_interpreter/keyword-util');


packageUtil.companyHasPackages = function(sessionContext, companyId, functionFindPackage){
    let dialog = companyId + "." + "pacotes";
    let findPaccote = functionFindPackage(dialog, sessionContext);

    console.log("Dialog"+dialog);
    console.log("Pacote Encontrado"+JSON.stringify(findPaccote));

    return findPaccote;
}

packageUtil.findPackageByTags = function(sessionContext, companyId, functionFindPackage, text){

    return new Promise( (resolve, reject) => {

      let findPackage = packageUtil.companyHasPackages(sessionContext, companyId, functionFindPackage);


      if (findPackage){

          console.log("achei package");

          let findCurrentPackage = findPackage.value.find(item => {

              text = KeywordUtil.removeSpecial(text);


              if (item.tags){
                  item.tags = item.tags.map(item => {
                      return KeywordUtil.removeSpecial(text);
                  })
              }

              return item.tags && packageUtil.isValidPackage(item) && KeywordUtil.hasWordInString(text, item.tags);
          });


          if (findCurrentPackage) {
              resolve(findCurrentPackage);
          }else{
              resolve(null);
          }

      }else{
          resolve(null);
      }

    })

}




packageUtil.findCurrentPackage = function(sessionContext, intent, companyId, functionFindPackage){

    return new Promise((resolve, reject) => {

        let sub = intent[API_AI_PARAMETER];

        if (sub && sub != "") {

            let findPaccote = packageUtil.companyHasPackages(sessionContext, companyId, functionFindPackage);

            if (findPaccote) {

                let findCurrentPackage = findPaccote.value.find(item => {
                    return item.holiday && (item.holiday.toLowerCase().trim() === sub.toLowerCase().trim() && packageUtil.isValidPackage(item));
                });

                if (findCurrentPackage) {
                    resolve(findCurrentPackage);
                }else{

                    let dialog = companyId + "." + "pacotes.naoexiste";
                    let packageDialogNotFound = functionFindPackage(dialog, sessionContext)

                    if (packageDialogNotFound) {
                        reject({type: 'package_not_found_exists', key: dialog + ".package", holiday: sub, package: packageDialogNotFound});
                    }else{
                       reject({type: 'package_not_found_not_exists'})
                    }
                }

            }else{
                reject({type: 'dialog_package_not_found'});
            }

        }else{
            reject({type: 'is_not_package'});
        }
    })

}


packageUtil.isValidPackage = function(packageAsk) {
    return (Date.parse(packageAsk.dateEnd)  > new Date()) && packageAsk.active;
};






module.exports = packageUtil;