let requestPromise = require('request-promise-native');
const Global = require('./global');


async function navigateWebsite(idHotel, checkin, checkout, adultos, criancas) {

    try {

        let options = {
            uri: Global.CRAWLER_ENDPOINT + '/desbravador',
            qs: {
                idHotel: idHotel,
                checkin: checkin,
                checkout: checkout,
                adultos: adultos,
                criancas: criancas
            },
            json: true // Automatically parses the JSON string in the response
        };

        let response = await requestPromise.get(options);

        return Promise.resolve(response);

    } catch (err) {
        console.log("caiu aqui no erro");
        console.error(err.error);
        return Promise.reject(err.error);
    }
}

// navigateWebsite('jlLdu30a3nYbAqyzGspDbRZUaDl39XtA7lWPYfHh9hkyU1YUV8H1ZKFQ76brDke%2FtvWGg7p%2Fy7vNuT2ot%2B%2B52Q%3D%3D', '06-06-2018', '10-06-2018', 2, 0).then(data => {
//     console.log(data);
//     console.log("sucesso")
// }).catch(error => {
//     console.log("caiu aqui");
//     console.log(error.message);
// });


// navigateWebsite('hMZchDCcE01WX4P6DZcumOMmBKR5WDjutMbG2UXDRfbd%2Bo9KMummXbxjWpxiHsEHP%2B7BiWew0PRFV6RbSzWfnA%3D%3D', '31-05-2018', '02-06-2018', 2, 0).then(data => {
//     console.log("sucesso")
// }).catch(error => {
//     console.log("caiu aqui");
//     console.log(error.message);
// });


module.exports = {search: navigateWebsite};



